"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.postOne = void 0;
const tslib_1 = require("tslib");
function postOne(options) {
    var _a, e_1, _b, _c;
    return tslib_1.__awaiter(this, void 0, void 0, function* () {
        const startTime = Date.now();
        const body = options.body;
        const target = this.repository.manager.create(this.repository.target, body.attributes);
        const prepareParams = Date.now() - startTime;
        if (body.relationships) {
            try {
                for (var _d = true, _e = tslib_1.__asyncValues(this.UtilsMethode.asyncIterateFindRelationships(body.relationships, this.repository)), _f; _f = yield _e.next(), _a = _f.done, !_a;) {
                    _c = _f.value;
                    _d = false;
                    try {
                        const relationships = _c;
                        target[relationships.propsName] = relationships.rel;
                    }
                    finally {
                        _d = true;
                    }
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (!_d && !_a && (_b = _e.return)) yield _b.call(_e);
                }
                finally { if (e_1) throw e_1.error; }
            }
        }
        const callQuery = Date.now() - startTime;
        return this.repository.save(target).then((r) => {
            const resultTransform = this.transform.transformData(r, []);
            const transform = Date.now() - startTime;
            const debug = {
                prepareParams,
                callQuery: callQuery - prepareParams,
                transform: transform - callQuery,
            };
            return {
                meta: Object.assign({}, (this.config.debug ? { debug } : {})),
                data: resultTransform,
            };
        });
    });
}
exports.postOne = postOne;
//# sourceMappingURL=post-one.js.map